#! /bin/sh

#
# Afghan's 'non-C' C preprocessor for text files.
# Effectively replaces all FOO's in a file $1 with values
# found from '#define FOO bar' in the file $3, outputs to
# $2. Might not work on pathological input: check your
# ALL UPPERCASE BITS don't contain substrings matching the
# #define's.
#
# Copyright (C) 2000 Afghan Hound Software
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA#

# Say what we're about to do

echo Processing $1 into $2 with defaults from $3

#
# Build a sed command file from #define's, escaping "/" and ".".
# #define WIBBLE /usr/string.thingy ->
# s/WIBBLE/\/usr\/string\.thingy/g

# NOTE - "NAME" gets escaped - I need it for the man pages
echo "s/NAME/OBNG/g" >> process.sed

grep "#define" $3      |\
sed  s/'\/\*.*\*\/'//g |\
sed  s/'#define'//g    |\
tr -d '"'|tr -s ' '    |\
sed  s/'\/'/'\\\/'/g   |\
sed  s/^\ /'s\/'/g     |\
sed  s/'\.'/'\\\.'/g   |\
sed  s/'\ '/'\/'/      |\
sed  s/'$'/'\/g'/g     |\
tr   -d ' '            |\
grep "s\/"             >> process.sed

# Just for the look of the thing: cpp does this automatically...
# (according to ANSI)
echo "s/__DATE__/`date +'%b %d %Y'`/g" >> process.sed
echo "s/__TIME__/`date +'%k:%M:%S'`/g" >> process.sed

# And back again
echo "s/OBNG/NAME/g" >> process.sed

# Do the processing.
sed -f process.sed $1 > $2

# Clean up.
rm  -f process.sed

# Finished!
echo "$1 made."
exit 0